local GuildFrame1 = CreateFrame("Frame")
local GuildFrame2 = CreateFrame("Frame")
local GuildFrame3 = CreateFrame("Frame")
local GuildFrame4 = CreateFrame("Frame")

local ShowOptions      = SuperGuildInviteGeneral.ShowOptions
local HideOptions      = SuperGuildInviteGeneral.HideOptions
local UpdateOptBtn     = SuperGuildInviteGeneral.UpdateOptBtn
local UpdateSpecOptBtn = SuperGuildInviteGeneral.UpdateSpecOptBtn
local ShowQuestion     = SuperGuildInviteGeneral.ShowQuestion

local version = "2.2"
local ID = "SG_INV"
local Options
local QuestionTime
local extra = 1



GuildFrame1:RegisterEvent("ZONE_CHANGED_NEW_AREA")
GuildFrame1:SetScript("OnEvent",function(self,event,...)
	local WhoReqZone = GetRealZoneText()
	if SuperGuildInviteOptions["OptBtn1"] and IsInGuild() and CanGuildInvite() then
		SetWhoToUI(1)
		SendWho("z-"..WhoReqZone.."")
		SuperGuildInviteGeneral["WhoSent"] = true
	elseif not IsInGuild() and SuperGuildInviteOptions["OptBtn1"] then
		ChatFrame1:AddMessage("SuperGuildInvite: You are not in a guild. SGI will automatically turn off.",0.5,1,1,1)
		SuperGuildInviteOptions["OptBtn1"] = false
		UpdateSpecOptBtn("OptBtn1")
	elseif not CanGuildInvite() and SuperGuildInviteOptions["OptBtn1"] then
		ChatFrame1:AddMessage("SuperGuildInvite: You cannot invite players to your Guild. SGI will automatically turn off.",0.5,1,1,1)
		SuperGuildInviteOptions["OptBtn1"] = false
		UpdateSpecOptBtn("OptBtn1")
	end
end)


GuildFrame2:RegisterEvent("WHO_LIST_UPDATE")
GuildFrame2:SetScript("OnEvent",function(self,event,...)
	if SuperGuildInviteGeneral["WhoSent"] and SuperGuildInviteOptions["OptBtn1"] then
		SuperGuildInviteGeneral["WhoSent"] = false
		local NumWho = GetNumWhoResults()
			for i = 1,NumWho do
				local name, guild = GetWhoInfo(i)
				if guild == "" then 
					print(" ")
					ChatFrame1:AddMessage(name.." is not a member of any guild.",1,0.2,0.2,1)
					InviteTime = tonumber(date("%j"))
					if SuperGuildInviteOptions["HourOptBtn4"] == 1 then
						extra = 0
					elseif SuperGuildInviteOptions["HourOptBtn4"] == 2 then
						extra = 1
					else
						extra = 2
					end
					if not SuperGuildInviteGeneral[name] or InviteTime > (extra + SuperGuildInviteGeneral[name]) then
						SuperGuildInviteGeneral[name] = InviteTime
						GuildInvite(name)
						if SuperGuildInviteOptions["OptBtn2"] then
							gName = GetGuildInfo(UnitName("Player"))
							gLevel = GetGuildLevel()
							SendChatMessage("Hello! Would you like to join the level "..gLevel.." Guild <"..gName.."> for much fun and leveling? Then press Accept!","WHISPER",nil,name)
						end
						ChatFrame1:AddMessage("SuperGuildInvite tried to invite "..name.." to your Guild.",0.28,0.46,1,1)
					else
						ChatFrame1:AddMessage(name.." has declined invitation less than one day ago. Will not try to invite again today.",0.93,0.705,0.13,1)
					end
				end
			end
		if SuperGuildInviteOptions["OptBtn3"] then
			FriendsFrame:Hide()
		end
	end
end)


GuildFrame3:RegisterEvent("PLAYER_LOGIN")
GuildFrame3:SetScript("OnEvent",function(self,event,...)
	if type(SuperGuildInviteGeneral) ~= "table" or tonumber(date("%j")) < (SuperGuildInviteGeneral[UnitName("Player")] or 0) then --New user or new year
		SuperGuildInviteGeneral = {}
		SuperGuildInviteGeneral[UnitName("Player")] = tonumber(date("%j"))
	end
	if type(SuperGuildInviteOptions) ~= "table" then
		SuperGuildInviteOptions = {}
		SuperGuildInviteOptions["OptBtn1"] = true
	end
	ChatFrame1:AddMessage("SuperGuildInvite: type /sgi followed by: config, hide, reset, toggle, on or off",0.5,1,1,1)
	if SuperGuildInviteOptions["OptBtn1"] then
		ChatFrame1:AddMessage("SuperGuildInvite is ON",0,1,0,1)
	else
		ChatFrame1:AddMessage("SuperGuildInvite is OFF",1,0,0,1)
	end
	QuestionTime = tonumber(date("%j"))
	if (QuestionTime-7) >= (SuperGuildInviteGeneral["QuestionTime"] or 0) then
		ShowQuestion()
		SuperGuildInviteGeneral["QuestionTime"] = QuestionTime
	end
	SendAddonMessage(ID,version,"GUILD")
end)

GuildFrame4:RegisterEvent("CHAT_MSG_ADDON")
GuildFrame4:SetScript("OnEvent",function(self,event,...)
	local prefix = select(1,...)
	if prefix == ID then
		local Message = select(2,...)
		if tonumber(version)<tonumber(Message) then
			ChatFrame1:AddMessage("A new version ("..Message..") of SuperGuildInvite is available",0.5,1,1,1)
		end
	end
end)


SLASH_SUPERGUILDINVITE1,SLASH_SUPERGUILDINVITE2 = '/sgi','/superguildinvite'

function SlashCmdList.SUPERGUILDINVITE(msg,editbox)
	if msg == 'toggle' then
		if SuperGuildInviteOptions["OptBtn1"] then
			UpdateSpecOptBtn("OptBtn1")
			SuperGuildInviteOptions["OptBtn1"] = false
			ChatFrame1:AddMessage("SuperGuildInvite is now OFF",1,0,0,1)
		else
			UpdateSpecOptBtn("OptBtn1")
			SuperGuildInviteOptions["OptBtn1"] = true
			ChatFrame1:AddMessage("SuperGuildInvite is now ON",0,1,0,1)
		end
	elseif msg == 'config' then
		Options = ShowOptions(Options,version)
		SuperGuildInviteOptions["TheOptionsFrame"] = Options
	elseif msg == 'hide' then
		HideOptions(Options)
	elseif msg == 'on' then
		SuperGuildInviteOptions["OptBtn1"] = true
		ChatFrame1:AddMessage("SuperGuildInvite is now ON",0,1,0,1)
	elseif msg == 'off' then
		SuperGuildInviteOptions["OptBtn1"] = false
		ChatFrame1:AddMessage("SuperGuildInvite is now OFF",1,0,0,1)
	elseif msg == 'reset' then
		SuperGuildInviteGeneral = {}
		ChatFrame1:AddMessage("SuperGuildInvite has reset all previous encounters.",1,0.2,0.2,1)
	elseif msg == '' then
		ChatFrame1:AddMessage("SuperGuildInvite: type /sgi followed by: config, hide, reset, toggle, on or off",0.5,1,1,1)
	end
end