-- ********************************** --
-- * Functions for SuperGuildInvite * --
-- *		  Written by            * --
-- *   Janniie - Stormreaver EU     * --
-- ********************************** --


local function SetSavedFramePos(Frame)
	if not Frame then print("Error: No frame") end
	
	local name = Frame:GetName()

	SuperGuildInviteOptions[name.."Xpos"] = SuperGuildInviteOptions[name.."Xpos"] or 0
	SuperGuildInviteOptions[name.."Ypos"] = SuperGuildInviteOptions[name.."Ypos"] or 0
	SuperGuildInviteOptions[name.."P1"] = SuperGuildInviteOptions[name.."P1"] or "CENTER"
	SuperGuildInviteOptions[name.."P2"] = SuperGuildInviteOptions[name.."P2"] or "CENTER"

	
	Frame:SetPoint(SuperGuildInviteOptions[name.."P1"],UIParent,SuperGuildInviteOptions[name.."P2"],SuperGuildInviteOptions[name.."Xpos"],SuperGuildInviteOptions[name.."Ypos"])
end

local function SaveCurFramePos(Frame)
	if not Frame then print("Error: No frame") end
	
	local name = Frame:GetName()

	local point, relativeTo, relativePoint, xOfs, yOfs = Frame:GetPoint()

	SuperGuildInviteOptions[name.."Xpos"] = xOfs
	SuperGuildInviteOptions[name.."Ypos"] = yOfs
	SuperGuildInviteOptions[name.."P1"] = point
	SuperGuildInviteOptions[name.."P2"] = relativePoint
end

local function UpdateOptBtn(self)
	if not self then print("ERROR: no button!") return end
	local Font = SuperGuildInviteOptions["Font"..self:GetName()]
	local ID = Font:GetText()
	if SuperGuildInviteOptions[self:GetName()] then
		Font:SetTextColor(1,0,0)
		SuperGuildInviteOptions[self:GetName()] = false
		if ID == "Enable SuperGuildInvite" then
			ChatFrame1:AddMessage("SuperGuildInvite is now OFF",1,0,0,1)
		elseif ID == "Send a whisper before inviting" then 
			ChatFrame1:AddMessage("SuperGuildInvite will NOT whisper before inviting",1,0,0,1)
		elseif ID == "Auto-close after Who search" then
			ChatFrame1:AddMessage("SuperGuildInvite WONT close the Who window automatically",1,0,0,1)
		end
	else
		Font:SetTextColor(0,1,0)
		SuperGuildInviteOptions[self:GetName()] = true
		if ID == "Enable SuperGuildInvite" then
			ChatFrame1:AddMessage("SuperGuildInvite is now ON",0,1,0,1)
		elseif ID == "Send a whisper before inviting" then 
			ChatFrame1:AddMessage("SuperGuildInvite WILL whisper before inviting",0,1,0,1)
		elseif ID == "Auto-close after Who search" then
			ChatFrame1:AddMessage("SuperGuildInvite WILL close the Who window automatically",0,1,0,1)
		end
	end
	if ID == "Reinvite lockout: 24 hours" and SuperGuildInviteOptions["Hour"..self:GetName()] == 1 then
		Font:SetText("Reinvite lockout: 48 hours")
		Font:SetTextColor(0.7,0.23,0.93)
		ChatFrame1:AddMessage("SuperGuildInvite will try to reinvite players at most every 48 hours",0.5,1,1,1)
		SuperGuildInviteOptions["Hour"..self:GetName()] = 2
	elseif ID == "Reinvite lockout: 48 hours" and SuperGuildInviteOptions["Hour"..self:GetName()] == 2 then
		Font:SetText("Reinvite lockout: 72 hours")
		Font:SetTextColor(0.5,1,1)
		ChatFrame1:AddMessage("SuperGuildInvite will try to reinvite players at most every 72 hours",0.5,1,1,1)
		SuperGuildInviteOptions["Hour"..self:GetName()] = 3
	elseif ID == "Reinvite lockout: 72 hours" then
		Font:SetText("Reinvite lockout: 24 hours")
		Font:SetTextColor(0.2,0.7,0.5)
		ChatFrame1:AddMessage("SuperGuildInvite will try to reinvite players at most every 24 hours",0.5,1,1,1)
		SuperGuildInviteOptions["Hour"..self:GetName()] = 1
	end
end

local function UpdateSpecOptBtn(FrameName)
	if not FrameName then print("ERROR: no button!") return end
	local Font = SuperGuildInviteOptions["Font"..FrameName]
	if SuperGuildInviteOptions[FrameName] then
		Font:SetTextColor(1,0,0)
		SuperGuildInviteOptions[FrameName] = false
	else
		Font:SetTextColor(0,1,0)
		SuperGuildInviteOptions[FrameName] = true
	end
end



if type(SuperGuildInviteGeneral) ~= "table" then
	SuperGuildInviteGeneral = {}
	SuperGuildInviteGeneral.SetSavedFramePos     = SetSavedFramePos
	SuperGuildInviteGeneral.SaveCurFramePos      = SaveCurFramePos
	SuperGuildInviteGeneral.UpdateOptBtn         = UpdateOptBtn
	SuperGuildInviteGeneral.UpdateSpecOptBtn     = UpdateSpecOptBtn
else
	SuperGuildInviteGeneral.SetSavedFramePos     = SetSavedFramePos
	SuperGuildInviteGeneral.SaveCurFramePos      = SaveCurFramePos
	SuperGuildInviteGeneral.UpdateOptBtn         = UpdateOptBtn
	SuperGuildInviteGeneral.UpdateSpecOptBtn     = UpdateSpecOptBtn
end
